SystemOrganization addCategory: #'Epic-Library'!

Object subclass: #EAuthor
	instanceVariableNames: 'firstName lastName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
firstName
	"Answer the value of firstName"

	^ firstName! !

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
firstName: anObject
	"Set the value of firstName"

	firstName := anObject! !

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
lastName
	"Answer the value of lastName"

	^ lastName! !

!EAuthor methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:37'!
lastName: anObject
	"Set the value of lastName"

	lastName := anObject! !

Object subclass: #EBook
	instanceVariableNames: 'isbn title authors copies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EBook class methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 14:15'!
descriptionCopies
	^ MANumberDescription new
		selectorAccessor: #copies;
		label: 'Number of copies';
		priority: 30;
		default: '1';
		yourself! !

!EBook class methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 14:12'!
descriptionISBN
	^ MAStringDescription new
		selectorAccessor: #isbn;
		label: 'ISBN';
		priority: 20;
		default: '';
		yourself! !

!EBook class methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 14:14'!
descriptionTitle
	^ MAStringDescription new
		selectorAccessor: #title;
		label: 'Title';
		priority: 10;
		default: '';
		yourself! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
authors
	"Answer the value of authors"

	^ authors! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 20:39'!
copies
	"Answer the value of copies"

	^ copies! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 20:39'!
copies: anObject
	"Set the value of copies"

	copies := anObject! !

!EBook methodsFor: 'accessing' stamp: 'sec 10/19/2010 14:46'!
descriptionReport
	^ super description 
		select: [:each | #(title isbn copies) includes: each accessor selector ].! !

!EBook methodsFor: 'initialize-release' stamp: 'RS 10/18/2010 20:45'!
initialize
	self 
		authors: OrderedCollection new;
		copies: 1.
	! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
isbn
	"Answer the value of isbn"

	^ isbn! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
isbn: anObject
	"Set the value of isbn"

	isbn := anObject! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
title
	"Answer the value of title"

	^ title! !

!EBook methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:36'!
title: anObject
	"Set the value of title"

	title := anObject! !

Object subclass: #EImageDatabase
	instanceVariableNames: ''
	classVariableNames: 'Books'
	poolDictionaries: ''
	category: 'Epic-Library'!

!EImageDatabase class methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 20:20'!
books
	^ Books ifNil: [Books := OrderedCollection new]! !

Object subclass: #EUser
	instanceVariableNames: 'id email password firstName lastName borrowedBooks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:46'!
borrowedBooks
	"Answer the value of borrowedBooks"

	^ borrowedBooks! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:46'!
borrowedBooks: anObject
	"Set the value of borrowedBooks"

	borrowedBooks := anObject! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
email
	"Answer the value of email"

	^ email! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
email: anObject
	"Set the value of email"

	email := anObject! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
firstName
	"Answer the value of firstName"

	^ firstName! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
firstName: anObject
	"Set the value of firstName"

	firstName := anObject! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
id
	"Answer the value of id"

	^ id! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
id: anObject
	"Set the value of id"

	id := anObject! !

!EUser methodsFor: 'initialize-release' stamp: 'RS 10/18/2010 16:46'!
initialize
	self borrowedBooks: OrderedCollection new.! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
lastName
	"Answer the value of lastName"

	^ lastName! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
lastName: anObject
	"Set the value of lastName"

	lastName := anObject! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
password
	"Answer the value of password"

	^ password! !

!EUser methodsFor: 'accessing' stamp: 'RS 10/18/2010 16:32'!
password: anObject
	"Set the value of password"

	password := anObject! !

WAComponent subclass: #EBookComponent
	instanceVariableNames: 'books menuComponent listComponent report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:40'!
books
	"Answer the value of books"

	^ books! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 18:40'!
books: anObject
	"Set the value of books"

	books := anObject! !

!EBookComponent methodsFor: 'rendering' stamp: 'sec 10/19/2010 15:03'!
children
	^Array with: self menuComponent with: self report.! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 14:26'!
createBook
	|book|
	book := self call: EBook new asComponent addValidatedForm.
	book ifNotNil: [self listComponent items add: book].! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 15:05'!
deleteBook: aBook
	self books remove: aBook ifAbsent: [].! !

!EBookComponent methodsFor: 'rendering' stamp: 'sec 10/19/2010 14:58'!
editBook: aBook
	self call: (aBook asComponent) addValidatedForm.! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'sec 10/19/2010 15:03'!
initialize
	super initialize.
	
	self books: EImageDatabase books.
	
	self initializeReport.
	self initializeMenuComponent.! !

!EBookComponent methodsFor: 'initialize-release' stamp: 'RS 10/18/2010 19:46'!
initializeMenuComponent
	self menuComponent: (EMenuComponent new
			addEntry: 'New book' withAction: [self createBook];
			addEntry: 'List books' withAction: [];
			 yourself)! !

!EBookComponent methodsFor: 'initialize-release' stamp: 'sec 10/19/2010 15:05'!
initializeReport
	self report: (MAReport
		rows: self books
		description: EBook new descriptionReport).
	self report
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editBook: text: '[edit]';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #deleteBook: text: '[delete]';
			yourself).! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:43'!
menuComponent
	"Answer the value of menuComponent"

	^ menuComponent! !

!EBookComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:43'!
menuComponent: anObject
	"Set the value of menuComponent"

	menuComponent := anObject! !

!EBookComponent methodsFor: 'rendering' stamp: 'sec 10/19/2010 15:02'!
renderContentOn: html 
	html heading: 'Books'.
	html div with: self menuComponent.
	html div with: self report.! !

!EBookComponent methodsFor: 'accessing' stamp: 'sec 10/19/2010 14:46'!
report
	"Answer the value of report"

	^ report! !

!EBookComponent methodsFor: 'accessing' stamp: 'sec 10/19/2010 14:46'!
report: anObject
	"Set the value of report"

	report := anObject! !

!EBookComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 18:55'!
testBooks
	^ OrderedCollection 
		with: (EBook new 
			isbn: '3551551677';
			title: 'Harry Potter und der Stein der Weisen')
		with: (EBook new 
			isbn: '3551551685';
			title: 'Harry Potter und die Kammer des Schreckens')! !

WAComponent subclass: #ELibrary
	instanceVariableNames: 'bookComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!ELibrary class methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 21:21'!
canBeRoot
	^ true! !

!ELibrary methodsFor: 'accessing' stamp: 'sec 10/18/2010 22:32'!
bookComponent
	"Answer the value of bookComponent"

	^ bookComponent! !

!ELibrary methodsFor: 'accessing' stamp: 'sec 10/18/2010 22:32'!
bookComponent: anObject
	"Set the value of bookComponent"

	bookComponent := anObject! !

!ELibrary methodsFor: 'accessing' stamp: 'sec 10/18/2010 22:41'!
children
	^Array with: self bookComponent.! !

!ELibrary methodsFor: 'initialize-release' stamp: 'sec 10/18/2010 22:40'!
initialize
	super initialize.
	self bookComponent: EBookComponent new.! !

!ELibrary methodsFor: 'initialize-release' stamp: 'sec 10/18/2010 22:41'!
renderContentOn: html
	html render: self bookComponent.! !

WAComponent subclass: #EMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Epic-Library'!

!EMenuComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:38'!
addEntry: aString withAction: aBlock
	^ self entries add: aString -> aBlock! !

!EMenuComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:38'!
entries
	"Answer the value of entries"

	^ entries! !

!EMenuComponent methodsFor: 'accessing' stamp: 'RS 10/18/2010 19:38'!
entries: anObject
	"Set the value of entries"

	entries := anObject! !

!EMenuComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:39'!
initialize
	super initialize.	
	self entries: OrderedCollection new! !

!EMenuComponent methodsFor: 'as yet unclassified' stamp: 'RS 10/18/2010 19:37'!
renderContentOn: html 
	self entries
		do: [:entry | html anchor callback: entry value;
				 with: entry key]
		separatedBy: [html space]! !
